/*!
 * @file		AutoTextConfigDlg.cpp
 * @brief		뱸  ȭ
 * @author		Jinwoo.Lee(jinwoo.lee@nhn.com)
 * @date		2012-12-10 
 * @warning		뱸  ִ (m_vecAutoText) 0 ε Ctrl+0 Ī
                ڰ  Ʈ/޺ڽ 0 ε Ctrl+1 ĪǹǷ Ѵ.
 * @attention	Copyright 2012 NTS Corp. All rights reserved.
 * @update		2013.02.01. 'Ctrl + Shift + 0'  Vista  Windows 7 IME ȯ  Ű ǰ ־ .
                  ȣȯ  Combobox  ʰ ϰ,  vector iniϿ ״ . ڵ尡 . Ф
 */
#include "stdafx.h"
#include "NeMessenger.h"
#include "AutoTextConfigDlg.h"

#define BTN_WIDTH				90
#define BTN_HEIGHT				30
#define BTN_GAP_X				4

#define NO_SHORT_KEY			20

IMPLEMENT_DYNAMIC(CAutoTextConfigDlg, CDialog)

CAutoTextConfigDlg::CAutoTextConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoTextConfigDlg::IDD, pParent)
{
	m_nOriginalVectorIndex = -1;
	m_strOriginalContent = _T("");
	m_bSortAscending = true;
    ZeroMemory(&m_cfContentInput, sizeof(m_cfContentInput));        //lint !e1415
    ZeroMemory(&m_cfContentDefault, sizeof(m_cfContentDefault));    //lint !e1415
    ZeroMemory(&m_pfContent, sizeof(m_pfContent));                  //lint !e1415
}

CAutoTextConfigDlg::~CAutoTextConfigDlg()
{
	m_penBorder.DeleteObject();
}

void CAutoTextConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BTN_ADD, m_btnAdd);
	DDX_Control(pDX, IDC_BTN_SAVE, m_btnSave);
	DDX_Control(pDX, IDC_BTN_DELETE, m_btnDelete);
	DDX_Control(pDX, IDC_LIST, m_listAutotext);
	DDX_Control(pDX, IDC_COMBO_SHORTKEY, m_comboShortkey);
	DDX_Control(pDX, IDC_EDIT_CONTENT, m_editContent);
}


BEGIN_MESSAGE_MAP(CAutoTextConfigDlg, CDialog)
	ON_BN_CLICKED(IDC_BTN_ADD, &CAutoTextConfigDlg::OnBnClickedAdd)
	ON_BN_CLICKED(IDC_BTN_SAVE, &CAutoTextConfigDlg::OnBnClickedSave)
	ON_BN_CLICKED(IDC_BTN_DELETE, &CAutoTextConfigDlg::OnBnClickedDelete)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CAutoTextConfigDlg::OnLvnItemchangedList)
	ON_WM_ERASEBKGND()
	ON_NOTIFY(HDN_ITEMCLICK, 0, &CAutoTextConfigDlg::OnHdnItemclickList)
	ON_EN_SETFOCUS(IDC_EDIT_CONTENT, &CAutoTextConfigDlg::OnEnSetfocusEditContent)
	ON_EN_KILLFOCUS(IDC_EDIT_CONTENT, &CAutoTextConfigDlg::OnEnKillfocusEditContent)
END_MESSAGE_MAP()


BOOL CAutoTextConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(LoadStringFromResource(IDS_STRING393));	// 뱸 

	__ResourceLoad(TRUE);

	InitListCtrl();
	InitComboBox();
	InitRichedit();

	RefreshButtonState();

	MoveWindow(0, 0, 480, 400);
	CenterWindow();

	SetSkin();
	ReSizeCtrl();
	LoadAutoTextToList();

	return TRUE;
}

void CAutoTextConfigDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit)
	{
		// â  
		if(m_penBorder.m_hObject != NULL)
		{
			m_penBorder.DeleteObject();
		}	
		m_penBorder.CreatePen(PS_SOLID, 1, DEF_AUTOTEXT_BORDER_COLOR);

		// Button
		m_btnAdd.SetFont(&g_ftDefault9PT);
		m_btnSave.SetFont(&g_ftDefault9PT);
		m_btnDelete.SetFont(&g_ftDefault9PT);
	}

	m_btnAdd.SetWindowText(LoadStringFromResource(IDS_STRING581));
	m_btnSave.SetWindowText(LoadStringFromResource(IDS_STRING398));
	m_btnDelete.SetWindowText(LoadStringFromResource(IDS_STRING251));
}

void CAutoTextConfigDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CAutoTextConfigDlg::ReSizeCtrl()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	if (m_listAutotext.GetSafeHwnd())
	{
		m_listAutotext.MoveWindow(CRect(18, 59, 456, 167), TRUE);
	}

	if (m_comboShortkey.GetSafeHwnd())
	{
		m_comboShortkey.MoveWindow(CRect(72, 194, 188, 213), TRUE);
	}

	if (m_editContent.GetSafeHwnd())
	{
		CRect rtEdit(72, 221, 456, 277);
		m_editContent.MoveWindow(rtEdit, TRUE);
		rtEdit.MoveToXY(0, 0);
		rtEdit.DeflateRect(5, 6, 5, 0);
		m_editContent.SetRect(rtEdit);
	}

	if (m_btnAdd.GetSafeHwnd() && m_btnSave.GetSafeHwnd() && m_btnDelete.GetSafeHwnd())
	{
		CRect rcBtn(0, 0, 0, 0);
		rcBtn.left = (rcClient.Width() / 2) - (BTN_WIDTH / 2) - BTN_GAP_X - BTN_WIDTH;
		rcBtn.right = rcBtn.left + BTN_WIDTH;
		rcBtn.bottom = rcClient.bottom - 6;
		rcBtn.top = rcBtn.bottom - BTN_HEIGHT;

		m_btnAdd.MoveWindow(rcBtn, TRUE);
		m_btnAdd.Invalidate();

		rcBtn.OffsetRect(BTN_WIDTH + BTN_GAP_X, 0);
		m_btnSave.MoveWindow(rcBtn, TRUE);
		m_btnSave.Invalidate();

		rcBtn.OffsetRect(BTN_WIDTH + BTN_GAP_X, 0);
		m_btnDelete.MoveWindow(rcBtn, TRUE);
		m_btnDelete.Invalidate();
	}
}

BOOL CAutoTextConfigDlg::OnEraseBkgnd(CDC* pDC)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(pDC, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	//  μ
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);

	// ϴ μ
	memDC.MoveTo(0, rcClient.bottom - 48);
	memDC.LineTo(rcClient.right, rcClient.bottom - 48);

	// Ʈ Ʈ Border
	CRect rcList(0, 0, 0, 0);
	m_listAutotext.GetWindowRect(rcList);
	this->ScreenToClient(rcList);
	rcList.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(&rcList);

	CRect rcCombo(0, 0, 0, 0);
	m_comboShortkey.GetWindowRect(rcCombo);
	this->ScreenToClient(rcCombo);
	rcCombo.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(&rcCombo);

	CRect rcEdit(0, 0, 0, 0);
	m_editContent.GetWindowRect(rcEdit);
	this->ScreenToClient(rcEdit);
	rcEdit.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(&rcEdit);

	// ȳ 
	memDC.SetBkMode(TRANSPARENT);
	CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PT);
	COLORREF oldColor = memDC.SetTextColor(COLOR_LC_NORMAL_TEXT);

	CRect rtText(0, 0, 0, 0);
	rtText.SetRect(17, 36, rcClient.right - 10, 56);
	memDC.DrawText(LoadStringFromResource(IDS_STRING394), rtText, DT_LEFT|DT_NOPREFIX);

	rtText.SetRect(17, 195, 65, 215);
	memDC.DrawText(LoadStringFromResource(IDS_STRING395), rtText, DT_LEFT|DT_NOPREFIX);

	rtText.SetRect(17, 223, 65, 263);
	memDC.DrawText(LoadStringFromResource(IDS_STRING396), rtText, DT_LEFT|DT_NOPREFIX|DT_WORDBREAK);

	pDC->BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
	memDC.SetTextColor(oldColor);	
	memDC.SelectObject(pOldFont);

	return TRUE;
}

void CAutoTextConfigDlg::InitListCtrl()
{
	// Ʈ ÷ Width
	int colWidthList[] = {
		96,		// Ű
		325,	// 
		-1
	};

	// Ʈ ÷  
	CStringArray arrListHeaderTitle;
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING395));	// Ű
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING481));	// 

	InitListColumn(m_listAutotext, arrListHeaderTitle, colWidthList);
}

void CAutoTextConfigDlg::InitListColumn(CAutoTextListCtrl &list, CStringArray &strHeaderTitle, const int *arrWidth)
{
	// ÷ 
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_MINWIDTH | LVCF_WIDTH;

	int nColSeq = 0;

	// ÷  
	std::list<int> freezeColList;
	std::list<int> linkColList;

	for (int i = 0; i < strHeaderTitle.GetCount(); i++)
	{
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		lvcolumn.cxMin = 0;
		lvcolumn.cx = arrWidth[i];
		list.InsertColumn(i, &lvcolumn);
	}

	list.ModifyStyle(0, LVS_SINGLESEL);
	list.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_DOUBLEBUFFER);
	list.SetRowHeight(18);			// Ʈ   (21px)
	list.SetTextFont(&g_ftDefault9PT);	// Ʈ Ʈ 
	list.GetHeaderCtrl()->SetFont(&g_ftDefault9PT);
	list.RedrawWindow();
}

BOOL CAutoTextConfigDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN)
		{
			if (pMsg->hwnd == this->GetSafeHwnd())
			{
				return TRUE;
			}
		}
	}
	else if (IsCloseMsg(pMsg))
	{
		if (pMsg->hwnd == this->GetSafeHwnd())
		{
			//  ϴ  ִ Ȯ
			CString strChangedContent;
			m_editContent.GetWindowText(strChangedContent);

			if (strChangedContent.Compare(m_strOriginalContent) != 0)
			{
 				if (NMessageBox(this, LoadStringFromResource(IDS_STRING473), _T("Ntalk Biz"), MB_SAVECLOSE) == IDOK)
 					OnBnClickedSave();
			}

			EndDialog(0);
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

bool CAutoTextConfigDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CAutoTextConfigDlg::InitComboBox()
{
	m_comboShortkey.SetFont(&g_ftDefault9PT);
	m_comboShortkey.SetTextColor(COLOR_LC_NORMAL_TEXT);

	CString strShortKey = _T("");

	for (int i = 0; i <= NO_SHORT_KEY; i++)
	{
		if (i == 19)
			continue;

		strShortKey = GetShortKeyString(ComboIndexToVectorIndex(i));
		m_comboShortkey.AddString(strShortKey);
	}

	m_comboShortkey.SetCurSel(0);
	m_comboShortkey.EnableWindow(FALSE);
}

void CAutoTextConfigDlg::InitRichedit()
{
	//m_editContent.SetWordWrapMode(WBF_WORDBREAK);

	// Paragraph format
	memset(&m_pfContent, 0, sizeof(PARAFORMAT2));           //lint !e1415
	m_pfContent.cbSize = sizeof(PARAFORMAT2);
	m_pfContent.dwMask = PFM_SPACEBEFORE|PFM_SPACEAFTER|PFM_LINESPACING;
	m_pfContent.dySpaceBefore = 0;
	m_pfContent.bLineSpacingRule = 4;	// The dyLineSpacing member specifies the spacing from one line to the next, in twips.
	m_pfContent.dyLineSpacing = 270;	// ٰ 3px ߱  

	memset(&m_cfContentInput, 0, sizeof(CHARFORMAT2));      //lint !e1415
	m_cfContentInput.cbSize = sizeof(CHARFORMAT2);
	m_cfContentInput.dwMask = CFM_COLOR|CFM_SIZE|CFM_FACE|CFM_WEIGHT|CFM_OFFSET;
	m_cfContentInput.dwEffects = 0;
	m_cfContentInput.yOffset = 0;
	m_cfContentInput.crTextColor = RGB(34, 34, 34);
	m_cfContentInput.yHeight = 9 * 20;
	_tcscpy_s(m_cfContentInput.szFaceName, LF_FACESIZE, g_defaultFontFaceName);

	memset(&m_cfContentDefault, 0, sizeof(m_cfContentDefault));  //lint !e1415
	m_cfContentDefault.cbSize = sizeof(CHARFORMAT2);
	m_cfContentDefault.dwMask = CFM_COLOR|CFM_SIZE|CFM_FACE|CFM_WEIGHT|CFM_OFFSET;
	m_cfContentDefault.dwEffects = 0;
	m_cfContentDefault.yOffset = 10;
	m_cfContentDefault.crTextColor = RGB(136, 136, 136);
	m_cfContentDefault.yHeight = 9 * 20;
	_tcscpy_s(m_cfContentDefault.szFaceName, LF_FACESIZE, g_defaultFontFaceName);

	m_editContent.SetParaFormat(m_pfContent);
	m_editContent.SetDefaultCharFormat(m_cfContentDefault);
}

void CAutoTextConfigDlg::LoadAutoTextToList()
{
	m_listAutotext.DeleteAllItems();

	size_t AutoTextCount = GET_CONFIG()->m_vecAutoText.size();
	int nItem = 0;
	CString strShortKey = _T("");

	for (size_t i = 0; i < AutoTextCount; i++)
	{
		CClientConfig *cf = GET_CONFIG();
		std::vector<CString> *v =& cf->m_vecAutoText;
		CString strValue = GET_CONFIG()->m_vecAutoText[i];

		if (strValue.IsEmpty())
			continue;

		if (i < 10)
		{
			strShortKey.Format(_T("Ctrl + %d"), i);
		}
		else if (i < 20)
		{
			strShortKey.Format(_T("Ctrl + Shift + %d"), i - 10);
		}
		else
		{
			strShortKey.LoadString(IDS_STRING475);
		}

		m_listAutotext.InsertItem(LVIF_TEXT, nItem, strShortKey, 0, 0, 0, 0);
		m_listAutotext.SetItemText(nItem, 1, strValue);
		m_listAutotext.SetItemData(nItem, i);	// Vector Index 

		nItem++;
	}
	
	SortList(0);
	m_listAutotext.ResizeColumn();
}

void CAutoTextConfigDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	int nSelectItem = pNMLV->iItem;

	if (-1 == nSelectItem)	//   ʴ´ Ф
	{
		m_strOriginalContent = _T("");
		m_editContent.SetWindowText(m_strOriginalContent);
	}
	else
	{
		m_nOriginalVectorIndex = m_listAutotext.GetItemData(nSelectItem);
		m_comboShortkey.SetCurSel(VectorIndexToComboIndex(m_nOriginalVectorIndex));

		m_strOriginalContent = m_listAutotext.GetItemText(nSelectItem, 1);
		m_editContent.SetWindowText(m_strOriginalContent);
	}

	RefreshButtonState();

	*pResult = 0;
}

void CAutoTextConfigDlg::OnBnClickedAdd()
{
	//  ϴ  ִ Ȯ
	CString strChangedContent;
	m_editContent.GetWindowText(strChangedContent);

	if (strChangedContent.Compare(m_strOriginalContent) != 0)
	{
		if (NMessageBox(this, LoadStringFromResource(IDS_STRING479), _T("Ntalk Biz"), MB_YESNO) == IDYES)
		{
			OnBnClickedSave();
		}
	}
	if (!IsWindow(m_hWnd))
	{
		return;
	}

	UnSelectAll();
	m_btnDelete.EnableWindow(FALSE);
	m_btnSave.EnableWindow(TRUE);
	m_editContent.EnableWindow(TRUE);
	m_comboShortkey.EnableWindow(TRUE);

	int nComboIndex = 0;

	// ִ Ű ã´
	for (; nComboIndex < NO_SHORT_KEY; nComboIndex++)
	{
		if (!IsExistVectorIndex(ComboIndexToVectorIndex(nComboIndex)))
			break;
	}

	if (nComboIndex < NO_SHORT_KEY)
		m_comboShortkey.SetCurSel(nComboIndex);
	else 
		m_comboShortkey.SetCurSel(NO_SHORT_KEY);

	m_nOriginalVectorIndex = -1;
	m_strOriginalContent = _T("");

	m_editContent.SetSel(0, -1);
	m_editContent.Clear();
	m_editContent.SetDefaultCharFormat(m_cfContentDefault);
	m_editContent.SetWindowText(LoadStringFromResource(IDS_STRING397));
}

void CAutoTextConfigDlg::OnBnClickedSave()
{
	CString strChangedContent;
	m_editContent.GetWindowText(strChangedContent);

	// Էµ  ȿ ˻
	if (strChangedContent.IsEmpty() || strChangedContent.CompareNoCase(LoadStringFromResource(IDS_STRING397)) == 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING478), _T("Ntalk Biz"), MB_OK);
		if (IsWindow(m_editContent.m_hWnd))
		{
			m_editContent.SetFocus();
		}

		return;
	}
	else if (strChangedContent.GetLength() > 500)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING397), _T("Ntalk Biz"), MB_OK);
		if (IsWindow(m_editContent.m_hWnd))
		{
			m_editContent.SetFocus();
		}


		return;
	}

	int nChangedComboIndex = m_comboShortkey.GetCurSel();
	int nChangedVectorIndex = ComboIndexToVectorIndex(nChangedComboIndex);

	if (IsExistVectorIndex(nChangedVectorIndex) && m_nOriginalVectorIndex != nChangedVectorIndex)
	{
		if (NMessageBox(this, LoadStringFromResource(IDS_STRING476), _T("Ntalk Biz"), MB_OKCANCEL) != IDOK)
		{
			if (IsWindow(m_comboShortkey.m_hWnd))
			{
				m_comboShortkey.SetCurSel(NO_SHORT_KEY);
			}
			
			return;
		}

		//  Ҵ 뱸 'Ű ' ̵
		InsertAutoTextToNoShortKey(NO_SHORT_KEY, GET_CONFIG()->m_vecAutoText[nChangedVectorIndex]);
		UpdateAutoTextWithShortKey(nChangedVectorIndex, strChangedContent);
	}
	else if (m_nOriginalVectorIndex == nChangedVectorIndex)
	{
		UpdateAutoTextWithShortKey(nChangedVectorIndex, strChangedContent);
	}
	else if (m_nOriginalVectorIndex == -1)
	{
		InsertAutoTextToNoShortKey(nChangedVectorIndex, strChangedContent);
	}
	else
	{
		DeleteAutoText(m_nOriginalVectorIndex);
		InsertAutoTextToNoShortKey(nChangedVectorIndex, strChangedContent);
	}

	GET_CONFIG()->SaveAutoText();
	RefreshButtonState();

	m_bSortAscending = true;
	SortList(0);
	m_listAutotext.ResizeColumn(); 
}

void CAutoTextConfigDlg::OnBnClickedDelete()
{
	int nSelectedItem = GetSelectedItemIndex();

	if (nSelectedItem >= 0)
	{
		if (NMessageBox(this, LoadStringFromResource(IDS_STRING477), _T("Ntalk Biz"), MB_YESNO) != IDYES)
			return;

		int nVectorIndex = m_listAutotext.GetItemData(nSelectedItem);

		DeleteAutoText(nVectorIndex);
		GET_CONFIG()->SaveAutoText();

		RefreshButtonState();
		m_listAutotext.ResizeColumn();
	}
}

bool CAutoTextConfigDlg::IsExistVectorIndex(int nVectorIndex)
{
	// Ҵ Ű  ߺ  
	if (nVectorIndex >= NO_SHORT_KEY)
		return false;

	CString strContent = GET_CONFIG()->m_vecAutoText[nVectorIndex];

	//   ش Ű ִ 
	if (strContent.IsEmpty())
		return false;

	return true;
}

// Ű ִ 뱸 Ʈ Ѵ. ( Ҵ Ű ִ  )
void CAutoTextConfigDlg::UpdateAutoTextWithShortKey(int nVectorIndex, CString strContent)
{
	if (0 > nVectorIndex || nVectorIndex >= NO_SHORT_KEY)
		return;

	if (strContent.IsEmpty())
		return;

	GET_CONFIG()->m_vecAutoText[nVectorIndex] = strContent;
	
	for (int i = 0; i < m_listAutotext.GetItemCount(); i++)
	{
		int nShortKeyData = m_listAutotext.GetItemData(i);

		if (nShortKeyData == nVectorIndex)
		{
			m_listAutotext.SetItemText(i, 1, strContent);
		}
	}
}

void CAutoTextConfigDlg::InsertAutoTextToNoShortKey(int nVectorIndex, CString strContent)
{
	if (nVectorIndex >= NO_SHORT_KEY)
	{
		GET_CONFIG()->m_vecAutoText.push_back(strContent);
		nVectorIndex = GET_CONFIG()->m_vecAutoText.size() - 1;
	}
	else
	{
		GET_CONFIG()->m_vecAutoText[nVectorIndex] = strContent;
	}

	int nInsertIndex = m_listAutotext.GetItemCount();
	CString strShortKey = GetShortKeyString(nVectorIndex);

	m_listAutotext.InsertItem(LVIF_TEXT, nInsertIndex, strShortKey, 0, 0, 0, 0);
	m_listAutotext.SetItemText(nInsertIndex, 1, strContent);
	m_listAutotext.SetItemData(nInsertIndex, nVectorIndex);
}

void CAutoTextConfigDlg::RefreshButtonState()
{
	int nSelectedCount = m_listAutotext.GetSelectedCount();

	if (nSelectedCount == 0)
	{
		m_btnSave.EnableWindow(FALSE);
		m_btnDelete.EnableWindow(FALSE);
		m_editContent.EnableWindow(FALSE);
		
		m_editContent.SetWindowText(_T(""));
		m_comboShortkey.SetCurSel(NO_SHORT_KEY);
		m_comboShortkey.EnableWindow(FALSE);

		m_nOriginalVectorIndex = -1;
		m_strOriginalContent = _T("");
	}
	else
	{
		m_btnSave.EnableWindow(TRUE);
		m_btnDelete.EnableWindow(TRUE);
		m_editContent.EnableWindow(TRUE);
		m_comboShortkey.EnableWindow(TRUE);
	}

}

void CAutoTextConfigDlg::DeleteAutoText(int nVectorIndex)
{
	if (nVectorIndex < NO_SHORT_KEY)
	{
		GET_CONFIG()->m_vecAutoText[nVectorIndex] = _T("");
	}
	else
	{
		vector<CString>::iterator Iter = GET_CONFIG()->m_vecAutoText.begin();
		int nCount = 0;

		for (; Iter != GET_CONFIG()->m_vecAutoText.end(); Iter++)
		{
			if (nCount == nVectorIndex)
			{
				GET_CONFIG()->m_vecAutoText.erase(Iter);
				break;
			}
			nCount++;
		}

		// ƮƮ Data ε ϳ  ش
		for (int i = 0; i < m_listAutotext.GetItemCount(); i++)
		{
			int nIndexData = m_listAutotext.GetItemData(i);

			if (nVectorIndex < nIndexData)
			{
				m_listAutotext.SetItemData(i, nIndexData - 1);
			}
		}
	}

	int nSelectedItem = GetSelectedItemIndex();
	m_listAutotext.DeleteItem(nSelectedItem);
}

int CAutoTextConfigDlg::ComboIndexToVectorIndex(int nComboIndex)
{
	// ޺ڽ [Ctrl + 1] ϰ, Vector ʹ [Ctrl + 0] ϱ   Ѵ.
	//   ޺ڽ 0°  'Ctrl+1'̰,   Vector 1° ̴.
	//   ޺ڽ 9°  'Ctrl+0'̰,   Vector 0° ̴.
	if (nComboIndex == 9)
	{
		return nComboIndex - 9;
	}
	else if (nComboIndex == 19)
	{
		return NO_SHORT_KEY;
	}
	else
	{
		return nComboIndex + 1;
	}
}

int CAutoTextConfigDlg::VectorIndexToComboIndex(int nVectorIndex)
{
	if (nVectorIndex == 0)
	{
		return nVectorIndex + 9;
	}
	else if (nVectorIndex == 10 || nVectorIndex >= NO_SHORT_KEY)
	{
		return 19;
	}
	else
	{
		return nVectorIndex -1;
	}
}

CString CAutoTextConfigDlg::GetShortKeyString(int nVectorIndex)
{
	CString strShortKey;
	strShortKey.LoadString(IDS_STRING475);

	if (nVectorIndex < 10)
	{
		strShortKey.Format(_T("Ctrl + %d"), nVectorIndex);
	}
	else if (nVectorIndex < 20)
	{
		strShortKey.Format(_T("Ctrl + Shift + %d"), nVectorIndex - 10);
	}

	return strShortKey;
}

int CAutoTextConfigDlg::GetSelectedItemIndex()
{
	int nSelectedItem = -1;
	POSITION pos = m_listAutotext.GetFirstSelectedItemPosition();

	if (pos)
		nSelectedItem = m_listAutotext.GetNextSelectedItem(pos);

	return nSelectedItem;
}

void CAutoTextConfigDlg::OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);

	SortList(phdr->iItem);

	*pResult = 0;
}

void CAutoTextConfigDlg::SortList(int nSortColumn)
{
	SORTPARAM sortParam;

	sortParam.pList = &m_listAutotext;
	sortParam.bSortAscending = m_bSortAscending;
	sortParam.nSortColumn = nSortColumn;

	m_listAutotext.SortItems(SortFunc, (LPARAM)&sortParam);
	m_bSortAscending = !m_bSortAscending;
}

int CALLBACK CAutoTextConfigDlg::SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORTPARAM *pSortParam = (SORTPARAM *)lParamSort;
	CAutoTextListCtrl *pList = pSortParam->pList;
	int nSortColumn = pSortParam->nSortColumn;
	bool bSortAscending = pSortParam->bSortAscending;

	LVFINDINFO info1, info2;
	info1.flags = LVFI_PARAM;
	info1.lParam = lParam1;
	info2.flags = LVFI_PARAM;
	info2.lParam = lParam2;
	int nRow1 = pList->FindItem(&info1, -1);
	int nRow2 = pList->FindItem(&info2, -1);

	int nRet = 0;

	if (nSortColumn == 0)
	{
		int nItem1 = VectorIndexToComboIndex(pList->GetItemData(nRow1));
		int nItem2 = VectorIndexToComboIndex(pList->GetItemData(nRow2));

		nRet = bSortAscending ? (nItem1 - nItem2) : -(nItem1 - nItem2);
	}
	else
	{
		CString strItem1 = pList->GetItemText(nRow1, nSortColumn);
		CString strItem2 = pList->GetItemText(nRow2, nSortColumn);

		nRet = bSortAscending ? strItem1.CompareNoCase(strItem2) : -strItem1.CompareNoCase(strItem2);
	}

	return nRet;
}

void CAutoTextConfigDlg::UnSelectAll()
{
	// Select all of the items that are completely visible.
	int nLast = m_listAutotext.GetItemCount();

	for (int i = 0; i < nLast; i++)
	{
		if (m_listAutotext.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{
			m_listAutotext.SetItemState(i, 0, LVIS_SELECTED);
		} 
	} 
}

void CAutoTextConfigDlg::OnEnSetfocusEditContent()
{
	CString strEditText;
	m_editContent.GetWindowText(strEditText);

	if (strEditText.CompareNoCase(LoadStringFromResource(IDS_STRING397)) == 0)	// ִ 500ڱ Է  ֽϴ.
	{
		m_editContent.SetSel(0, -1);
		m_editContent.Clear();
		m_editContent.SetDefaultCharFormat(m_cfContentInput);
	}
}

void CAutoTextConfigDlg::OnEnKillfocusEditContent()
{
	CString strEditText;
	m_editContent.GetWindowText(strEditText);

	if (strEditText.IsEmpty())
	{
		m_editContent.SetDefaultCharFormat(m_cfContentDefault);
		m_editContent.SetWindowText(LoadStringFromResource(IDS_STRING397));
	}
}

void CAutoTextConfigDlg::CloseDlg()
{
	CDialog::OnCancel();
	DestroyWindow();
}
